// -------------------------------------------------------------
// [teNX`
// 
// Copyright (c) 2003 IMAGIRE Takashi. All rights reserved.
// -------------------------------------------------------------

// -------------------------------------------------------------
// O[oϐ
// -------------------------------------------------------------
float4x4 mWVP;		// [JˉeԂւ̍Wϊ
float4   vLightDir; // Cg̕

// -------------------------------------------------------------
// -------------------------------------------------------------
//
// _WQceNX`Ƀ}bv
//
// -------------------------------------------------------------
// -------------------------------------------------------------

// -------------------------------------------------------------
// f[^󂯓n̂߂̍\
// -------------------------------------------------------------
// _VF[_̓f[^
struct VS_INPUT_Pos
{
	float4 Pos		: POSITION;
	float4 Tex		: TEXCOORD0;
};
// -------------------------------------------------------------
// _VF[_o̓f[^
struct VS_OUTPUT_Pos
{
	float4 Pos		: POSITION;
	float3 Tex		: TEXCOORD0;
};
// -------------------------------------------------------------
// sNZVF[_o̓f[^
struct PS_OUTPUT_Pos
{
	float4 Col		: COLOR0;
};
// -------------------------------------------------------------
// _VF[_vO
// -------------------------------------------------------------
VS_OUTPUT_Pos PosV ( VS_INPUT_Pos In )
{
	VS_OUTPUT_Pos Out = (VS_OUTPUT_Pos)0;        // o̓f[^
	float4 offsetS = { 2.0f, -2.0f, 0.0f, 0.0f};
	float4 offsetB = {-1.0f, +1.0f, 0.5f, 1.0f};
	
	// Wϊ
	Out.Pos = In.Tex * offsetS + offsetB;
	
	// eNX`W
	Out.Tex = 0.1f*In.Pos+0.5f;
	
	return Out;
}
// -------------------------------------------------------------
// sNZVF[_vO
// -------------------------------------------------------------
PS_OUTPUT_Pos PosP ( VS_OUTPUT_Pos In )
{
	
	PS_OUTPUT_Pos Out = ( PS_OUTPUT_Pos ) 0;
	
	Out.Col.xyz = In.Tex;
	
    return Out;
}
// -------------------------------------------------------------
// eNjbN
// -------------------------------------------------------------
technique TPos
{
    pass P0
    {
        CullMode = None;

        // VF[_
        VertexShader = compile vs_1_1 PosV();
        PixelShader  = compile ps_1_1 PosP();

    }
}


// -------------------------------------------------------------
// -------------------------------------------------------------
//
// אڂsNZƂ̋𑪂
//
// -------------------------------------------------------------
// -------------------------------------------------------------

texture TexPos;
sampler TexPosSamp = sampler_state
{
	Texture = <TexPos>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = NONE;

	AddressU = Clamp;
	AddressV = Clamp;
};
// -------------------------------------------------------------
// f[^󂯓n̂߂̍\
// -------------------------------------------------------------
// _VF[_̓f[^
struct VS_INPUT_Distance
{
	float4 Pos		: POSITION;
	float4 Tex		: TEXCOORD0;
};
// -------------------------------------------------------------
// _VF[_o̓f[^
struct VS_OUTPUT_Distance
{
	float4 Pos		: POSITION;
	float2 Tex		: TEXCOORD0;
};
// -------------------------------------------------------------
// sNZVF[_o̓f[^
struct PS_OUTPUT_Distance
{
	float4 Col		: COLOR0;
};
// -------------------------------------------------------------
// _VF[_vO
// -------------------------------------------------------------
VS_OUTPUT_Distance DistanceV ( VS_INPUT_Distance In )
{
	VS_OUTPUT_Distance Out = (VS_OUTPUT_Distance)0;        // o̓f[^
	
	// Wϊ
	Out.Pos = In.Pos;
	
	// eNX`W
	Out.Tex = In.Tex;
	
	return Out;
}
// -------------------------------------------------------------
// sNZVF[_vO
// -------------------------------------------------------------
PS_OUTPUT_Distance DistanceP ( VS_OUTPUT_Distance In )
{
	PS_OUTPUT_Distance Out = ( PS_OUTPUT_Distance ) 0;
	
	float2 dx = {1.0f/256.0f, 0.0f};
	float2 dy = {0.0f, 1.0f/256.0f};
	
	float3 center = tex2D( TexPosSamp, In.Tex );
	float3 left   = tex2D( TexPosSamp, In.Tex + dx ) - center;
	float3 down   = tex2D( TexPosSamp, In.Tex + dy ) - center;
	
	Out.Col.r = 100.0f*sqrt(dot(left,left));
	Out.Col.g = 100.0f*sqrt(dot(down,down));
	Out.Col.b = 100000.0f*abs(cross(left, down));
	
    return Out;
}
// -------------------------------------------------------------
// eNjbN
// -------------------------------------------------------------
technique TDistance
{
    pass P0
    {
        CullMode = None;

		// eNX`
        Sampler[0] = (TexPosSamp);
        
        // VF[_
        VertexShader = compile vs_1_1 DistanceV();
        PixelShader  = compile ps_2_0 DistanceP();

    }
}

// -------------------------------------------------------------
// -------------------------------------------------------------
//
// Ǝ˂ꂽCg̋߂
//
// -------------------------------------------------------------
// -------------------------------------------------------------

// -------------------------------------------------------------
// f[^󂯓n̂߂̍\
// -------------------------------------------------------------
// _VF[_̓f[^
struct VS_INPUT_Irradiance
{
	float4 Pos		: POSITION;
	float4 Normal	: NORMAL;
	float4 Tex		: TEXCOORD0;
};
// -------------------------------------------------------------
// _VF[_o̓f[^
struct VS_OUTPUT_Irradiance
{
	float4 Pos		: POSITION;
	float4 Color	: DIFFUSE;
};
// -------------------------------------------------------------
// _VF[_vO
// -------------------------------------------------------------
VS_OUTPUT_Irradiance IrradianceV ( VS_INPUT_Irradiance In )
{
	VS_OUTPUT_Irradiance Out = (VS_OUTPUT_Irradiance)0;// o̓f[^
	float4 offsetS = { 2.0f, -2.0f, 0.0f, 0.0f};
	float4 offsetB = {-1.0f, +1.0f, 0.5f, 1.0f};
	
	// Wϊ
	Out.Pos = In.Tex * offsetS + offsetB;
	
	// F
	Out.Color = vLightDir.w								 // F
			+ max( dot(vLightDir.xyz, In.Normal.xyz), 0);// gUF
	
	return Out;
}
// -------------------------------------------------------------
// sNZVF[_vO
// -------------------------------------------------------------
float4 IrradianceP ( VS_OUTPUT_Irradiance In ) : COLOR0
{
	float4 Col = 0;
	
	Col = In.Color;
	
    return Col;
}
// -------------------------------------------------------------
// eNjbN
// -------------------------------------------------------------
technique TIrradiance
{
    pass P0
    {
        Cullmode=None;

        // VF[_
        VertexShader = compile vs_1_1 IrradianceV();
        PixelShader  = compile ps_1_1 IrradianceP();

    }
}

// -------------------------------------------------------------
// -------------------------------------------------------------
//
// \ʉU}bv̍쐬
//
// -------------------------------------------------------------
// -------------------------------------------------------------

texture TexIrradiance;
sampler IrradianceSamp = sampler_state
{
	Texture = <TexIrradiance>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;

	AddressU = Clamp;
	AddressV = Clamp;
};

texture TexSubLight;
sampler SubLightSamp = sampler_state
{
	Texture = <TexSubLight>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;

	AddressU = Clamp;
	AddressV = Clamp;
};
// -------------------------------------------------------------
// f[^󂯓n̂߂̍\
// -------------------------------------------------------------
// _VF[_̓f[^
struct VS_INPUT_SubLight
{
	float4 Pos		: POSITION;
	float4 Tex		: TEXCOORD0;
};
// -------------------------------------------------------------
// _VF[_o̓f[^
struct VS_OUTPUT_SubLight
{
	float4 Pos		: POSITION;
	float2 Tex		: TEXCOORD0;
};
// -------------------------------------------------------------
// _VF[_vO
// -------------------------------------------------------------
VS_OUTPUT_SubLight SubLightV ( VS_INPUT_SubLight In )
{
	VS_OUTPUT_SubLight Out = (VS_OUTPUT_SubLight)0;// o̓f[^
	
	// Wϊ
	Out.Pos = In.Pos;
	
	// eNX`W
	Out.Tex = In.Tex;
	
	return Out;
}
// -------------------------------------------------------------
// sNZVF[_vO
// -------------------------------------------------------------
float4 SubLightP ( VS_OUTPUT_SubLight In ) : COLOR0
{
	float4 Col = 0;
	
	float4 irr = tex2D( IrradianceSamp, In.Tex );
	
	float2 offsetP0 = { +1.0f/256.0f, 0.0f };
	float2 offsetN0 = { -1.0f/256.0f, 0.0f };
	float2 offset0P = { 0.0f, +1.0f/256.0f };
	float2 offset0N = { 0.0f, -1.0f/256.0f };
	
	float4 colP0 = tex2D( SubLightSamp, In.Tex + offsetP0 );
	float4 colN0 = tex2D( SubLightSamp, In.Tex + offsetN0 );
	float4 col0P = tex2D( SubLightSamp, In.Tex + offset0P );
	float4 col0N = tex2D( SubLightSamp, In.Tex + offset0N );
	
	Col = 0.20f * irr
		+ 0.20f * (colP0 + colN0 + col0P + col0N);
	
    return Col;
}
// -------------------------------------------------------------
// eNjbN
// -------------------------------------------------------------
technique TSubLight
{
    pass P0
    {
        Cullmode=None;

		// eNX`
        Sampler[0] = (IrradianceSamp);
        Sampler[1] = (SubLightSamp);
        
        // VF[_
        VertexShader = compile vs_1_1 SubLightV();
        PixelShader  = compile ps_2_0 SubLightP();

    }
}

// -------------------------------------------------------------
// -------------------------------------------------------------
//
// Ǝ˂ꂽCg̋߂
//
// -------------------------------------------------------------
// -------------------------------------------------------------

texture TexDecale;
sampler DecaleSamp = sampler_state
{
	Texture = <TexDecale>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;

	AddressU = Clamp;
	AddressV = Clamp;
};
// -------------------------------------------------------------
// f[^󂯓n̂߂̍\
// -------------------------------------------------------------
// _VF[_̓f[^
struct VS_INPUT_Final
{
	float4 Pos		: POSITION;
	float4 Normal	: NORMAL;
	float4 Tex		: TEXCOORD0;
};
// -------------------------------------------------------------
// _VF[_o̓f[^
struct VS_OUTPUT_Final
{
	float4 Pos		: POSITION;
	float4 Color	: COLOR0;
	float4 Tex0		: TEXCOORD0;
	float4 Tex1		: TEXCOORD1;
};
// -------------------------------------------------------------
// _VF[_vO
// -------------------------------------------------------------
VS_OUTPUT_Final FinalV ( VS_INPUT_Irradiance In )
{
	VS_OUTPUT_Final Out = (VS_OUTPUT_Final)0;// o̓f[^
	
	// Wϊ
	Out.Pos = Out.Pos = mul(In.Pos, mWVP);
	
	Out.Tex0 = In.Tex;
	Out.Tex1 = In.Tex;
	
	// F
	Out.Color = vLightDir.w								 // F
			+ max( dot(vLightDir.xyz, In.Normal.xyz), 0);// gUF

	return Out;
}
// -------------------------------------------------------------
// sNZVF[_vO
// -------------------------------------------------------------
float4 FinalP ( VS_OUTPUT_Final In ) : COLOR0
{
	float4 Col = 0;
	
	float4 decale = tex2D( DecaleSamp,   In.Tex0 );
	float4 light  = saturate(1.0f*tex2D( SubLightSamp, In.Tex1 ));
//light=In.Color;
decale = float4(0.8f, 0.8f, 0.8f, 1.0f);// Fɂ
	Col = decale * light;
	
    return Col;
}
// -------------------------------------------------------------
// eNjbN
// -------------------------------------------------------------
technique TFinal
{
    pass P0
    {
		// eNX`
        Sampler[0] = (DecaleSamp);
        Sampler[1] = (SubLightSamp);

        // VF[_
        VertexShader = compile vs_1_1 FinalV();
        PixelShader  = compile ps_1_1 FinalP();

    }
}